# ifndef ARITMETICABASICA
    # include "AritmeticaBasica.h"
    # define ARITMETICABASICA
# endif // ARITMETICABASICA

void _porDiez (char * solucion);
void _potenciaDeDiez (int , char * solucion);
void _por_potenciaDeDiez (const char * , int , char * );
void _charXString (char c, const char * numero, char * result);
//void charDivideString (const char c, const char * numero, char *cociente, char * resto);
void _invierto (char * cadena);
void _cambiaSigno (char * numero);
void _simplificaIzquierda (char * cadena, char caracter);
void _valorAbsoluto (char * numero);
void _complementoA9 (const char * c1, int nMax, char * c2);
void _correALaDerecha (char * cadena);

//Dada una cadena de caracteres formada por dgitos, devuelve un entero con el valor representado por la cadena
//Ej: dado "123" devuelve el nmero 123
int cadenaAEntero (const char cadena [])
{
    int i=0, resultado=0, signo=1;

    if (cadena[0] == '-')
    {
        signo = -1;
        i++;
    }
    while (cadena[i] != '\0')
    {
        resultado = resultado * 10;
        resultado = resultado + cadena[i] - '0';
        i ++;
    }
    return signo*resultado;
}

//Dado un entero, devuelve una cadena cuyos caracteres corresponden con los dgitos del nmero
//Ej: Dado el nmero 123, devuelve "123"
void enteroACadena (int n, char * cadena)
{
    int i, signo =1;

    if (n==0)
      strcpy (cadena, "0");
    else
    {
        if (n<0)
        {
            signo = -1;
            n *= -1;
        }

        for (i=0; n!= 0; i++)
        {
            cadena[i] = n%10 + '0';
            n = n/10;
        }
        if (signo == -1) cadena [i++] = '-';
        cadena [i] = '\0';
        _invierto (cadena);
    }

}

//Elimina los caracteres iguales a 'caracter' a la izquierda de una cadena
//Ej: si cadena es "000123", _simplificaIzquierda (cadena, '0') transforma la cadena en "123"
void _simplificaIzquierda (char * cadena, char caracter)
{
    int i,inicio, longitud = strlen (cadena);

    for (inicio=0; cadena[inicio]== caracter && inicio< longitud; inicio++);

    if (inicio >0)
        for (i=inicio; i<=longitud; i++)
              cadena[i-inicio] = cadena [i];

    if (strlen (cadena) == 0) strcpy (cadena, "0");
}

//Desplaza todos los caracteres una posicin a la derecha
//Ejemplo: si cadena es "123", _correALaDerecha la transforma en "0123"
void _correALaDerecha (char * cadena)
{
    for (int i = strlen (cadena)+1; i>0; i--)
        cadena[i] = cadena [i-1];
    cadena[0] = '0';
}

//Devuelve el valor absoluto de un nmero
void _valorAbsoluto (char * numero)
{
    if (numero[0] == '-')
        _simplificaIzquierda (numero, '-');
}


//Calcula la suma de dos nmeros de nMax dgitos. Devuelve el resultado a travs del p.d.r. result
void sumaComplemento (const char * numero1, const char * numero2, int nMax, char * result)
{
    int i, i1, i2, l1, l2,  sum, llevo;

    l1 = strlen (numero1);
    l2 = strlen (numero2);


    char p1[l1+1], p2 [l2+1];
    strcpy (p1, numero1);
    strcpy (p2, numero2);

    result [nMax] = '\0';

    for (i = nMax-1, i1 = l1-1; i1 >= 0 && i>= 0; i1--, i--)
    {
        result[i] = p1[i1];
    }
    for (; i>= 0; i--)
        result[i] = '0';

    llevo = 0;
    for (i = nMax-1, i2 = l2-1; i2 >= 0; i2--, i--)
    {
        sum = result[i] + p2[i2] - 2 * '0' + llevo;
        result [i] = sum%10 + '0';
        llevo = sum/10;
    }
    for (; i>= 0; i--)
    {
        sum = result[i] +  - '0' + llevo;
        result [i] = sum%10 + '0';
        llevo = sum/10;
    }
}

//Calcula el complemento a 9 de un nmero usando nMax dgitos
//Ejemplo, si c1 es "123" y nMax vale 5, devuelve c2 <- "99877"
void _complementoA9 (const char * c1, int nMax, char * c2)
{
    int i1,i2;

    char p1 [nMax+1];
    strcpy (p1, c1);

    c2[nMax] = '\0';
    for (i1= strlen (c1)-1, i2 = nMax-1 ;  i1 >= 0 && i2 >= 0; i1 --, i2--)
       c2[i2] = '9' - p1[i1] +'0';
    for (; i2>= 0; i2--)
        c2[i2] = '9';


    sumaComplemento (c2,"1", nMax, c2);
}

//Calcula la suma de dos nmeros. La devuelve a travs del p.d.r. result
void suma (const char * numero1, const char * numero2, char * result)
{
    int l1 =strlen (numero1), l2 = strlen (numero2);

    int longitud = (l1>l2)?l1:l2;
    longitud ++;

    char p1[longitud+1], p2[longitud+1], r[longitud+1];
    strcpy (p1, numero1);
    strcpy (p2, numero2);


    if (p1[0] == '-') { _valorAbsoluto (p1); _complementoA9 (p1, longitud, p1); }
    if (p2[0] == '-') { _valorAbsoluto (p2);_complementoA9 (p2, longitud, p2); }
    sumaComplemento(p1, p2, longitud, r);

    if (r [0] > '5')
    {
        _complementoA9(r, longitud, r); //bastara comprobar que es >= '8';
        _simplificaIzquierda(r, '0');
        _correALaDerecha(r);
        r [0] = '-';
    }
    else
        _simplificaIzquierda(r, '0');

    if (strlen (r)== 0) strcpy (r, "0");
    strcpy (result, r);
}

//Cambia el signo de un nmero
void _cambiaSigno (char * numero)
{
    if (numero [0] == '-')
        _valorAbsoluto (numero);
    else
    {
        _correALaDerecha(numero);
        numero [0] = '-';
    }
}

//Resta dos nmeros
void resta (const char * numero1, const char * numero2, char * result)
{
    char p1[strlen (numero1)+1], p2[strlen (numero2)+2];
    strcpy (p1, numero1);
    strcpy (p2, numero2);

    _cambiaSigno (p2);

    suma (p1,p2, result);

    if (strlen (result) == 0) strcpy (result, "0");

}

//Invierte el orden de las componentes de una cadena:
// Ej: transforma "Hola" en "aloH"
void _invierto (char * cadena)
{
    int aux, i, l = strlen (cadena);
    for (i=0; i< l/2; i++)
    {
        aux = cadena[i] ; cadena[i] = cadena [l-i-1]; cadena [l-i-1] = aux;
    }
}

//Devuelve un nmero multiplicado por 10
void _porDiez (char solucion[])
{
    if (strcmp (solucion, "0") != 0) strcat (solucion, "0");
}

//Dado un nmero, lo  multiplica por 10^n
void _por_potenciaDeDiez (const char * numero, int n, char * solucion)
{
    strcpy (solucion, numero);
    for (int i=0;i< n ;i++) strcat (solucion, "0");
}

//Dado un entero n, devuelve el nmero 10^n
void _potenciaDeDiez (int n, char solucion[])
{
    strcpy (solucion, "1");
    for (int i=0; i<n; i++) strcat (solucion, "0");
}


int comparaPositivos (const char *n1, const char * n2)
{
    int  l1 = strlen (n1), l2 = strlen (n2);


    if (strcmp (n1, n2)==0)
        return 0;
    else
    {
        //Primero eliminamos ceros a la izquierda: "0001213" -> "1213"
        char aux1[l1+1], aux2[l2+1];
        strcpy (aux1, n1); strcpy (aux2, n2);
        _simplificaIzquierda(aux1,'0'); _simplificaIzquierda(aux2,'0');
        l1 = strlen (aux1), l2 = strlen (aux2);

        if (l1> l2) return 1;
        else if (l2 > l1) return -1;
        else return strcmp (aux1,aux2);

    }
}

int compara (const char n1[], const char n2[])
{
    if (strcmp (n1, n2)==0)
        return 0;
    else if (n1[0] != '-' && n2[0] != '-')
      return comparaPositivos (n1, n2);
    else if (n1[0] == '-' && n2[0] == '-')
        return comparaPositivos (n2, n1);
    else if (n1[0]!= '-')
        return 1;
    else
        return -1;
}

//Multiplica un nmero por un dgito (expresado mediante el carcter c).
//Devuelve el resultado a travs del p.d.r. result
void _charXString (char c, const char * numero, char * result)
{

    if (c == '0')
        strcpy (result, "0");
    else if (c== '1')
        strcpy (result, numero);
    else
    {
        int i, llevo, prod, nDigitos;
        nDigitos = strlen (numero);
        char aux[nDigitos+1];

        strcpy (aux, numero);

        result [nDigitos]= '\0';
        for (i=nDigitos-1, llevo = 0; i>= 0; i--)
        {
            prod = (aux[i] -'0' ) * (c - '0') + llevo;
            result [i] = prod%10 +'0';
            llevo = prod /10;
        }
        if (llevo > 0)
        {
            _correALaDerecha(result);
            result [0] = llevo + '0';
        }
    }



}

//Devuelve el cociente y el resto de la divisin Divisor/c, donde c representa un nmero de un solo dgito
/*void charDivideString (const char c, const char * Divisor, char *cociente, char * resto)
{
    int i, D, r, llevo, d;
    char numero [strlen(Divisor)+1];
    strcpy (numero, Divisor);

    d = c-'0';

    r = 0;
    for (i=0; i< strlen (numero); i++)
    {
        D = r * 10 + numero[i]-'0' ;
        cociente[i] = D/d + '0';
        r = D%d;
    }
    cociente[i] = '\0';
    resto[0] = r + '0';
    resto[1] = '\0';

    _simplificaIzquierda(cociente, '0');
}*/

//Multiplica dos nmeros positivos tal como se aprende en la escuela
void multiplicaEscuela (const char * f1, const char * f2, char * result)
{
    int i,indice, l1 = strlen(f1), l2=strlen(f2);
    char aux[10][l2+2];
    char n1[l1+1], n2[l2+1];

    strcpy (n1, f1);
    strcpy (n2, f2);

    strcpy (aux[0],"0");
    strcpy (aux[1], n2);
    for (char j='2'; j<='9'; j++)
    {
        _charXString(j, n2, aux[j-'0']);
    }

    strcpy (result, "0");
    for (i=0; i<l1; i++)
    {
        _porDiez(result);
        indice = n1[i]-'0';

        if (indice != 0)
            suma (result, aux[indice],result);

    }

}

//Multiplica dos nmeros.
void multiplicacion (const char * n1, const char * n2, char * result)
{
    int signo = 1;
    char p1[strlen (n1)+1], p2[strlen(n2)+1];

    strcpy (p1, n1);
    strcpy (p2, n2);


    if (p1[0] == '-')
    {
        signo *= -1;
        _valorAbsoluto (p1);
    }
    if (p2[0] == '-')
    {
        signo *= -1;
        _valorAbsoluto (p2);
    }

    multiplicaEscuela (p1, p2, result);

    if (signo == -1) _cambiaSigno (result);

}

void divideRestando (const char* D, const char* d, char * cociente, char * resto)
{
    int iCoc = 0;
    strcpy (resto, D);
    while (compara (resto, d) >= 0)
    {
        resta (resto, d, resto);
        iCoc ++;
    }
    enteroACadena(iCoc, cociente);
}

void divisionPositivos (const char* D, const char* d, char * cociente, char * resto)
{
    int i=0, lD = strlen (D),lResto, iCoc=0;
    char digito, digCoc[2];
    char DAux [lD+1], dAux[strlen(d)+1];

    strcpy (DAux, D);
    strcpy (dAux, d);
    strcpy (cociente, "0");
    strcpy (resto, "0");

    for (i=0, iCoc = 0; i< lD; i++, iCoc ++)
    {
        digito = DAux[i];
        lResto = strlen (resto);
        resto[lResto] = digito;
        resto[lResto+1] = '\0';

        divideRestando (resto, dAux, digCoc, resto);
        _porDiez (cociente);
        suma (cociente, digCoc, cociente);
    }
    _simplificaIzquierda (cociente,'0');
    _simplificaIzquierda (resto,'0');
}

void division (const char* D, const char* d, char * cociente, char * resto)
{
    int signoD=1, signod=1;
    char DAux[strlen(D)+1], dAux[strlen(d)+1];
    strcpy (DAux, D); strcpy (dAux, d);
    if (DAux[0] == '-')
    {
        signoD = -1;
        _valorAbsoluto(DAux);
    }
    if (dAux[0] == '-')
    {
        signod = -1;
        _valorAbsoluto(dAux);
    }
    divisionPositivos (DAux, dAux, cociente, resto);
    if (signoD == -1)
    {
        _correALaDerecha(resto);
        resto[0] = '-';
    }
    if (signoD*signod == -1)
    {
        _correALaDerecha(cociente);
        cociente[0] = '-';
    }
}


