# include "bibliotecasComunes.h"

# ifndef ARITMETICABASICA
    # include "AritmeticaBasica.h"
    # define ARITMETICABASICA
# endif // ARITMETICABASICA

# ifndef ALGORITMOSRSA
    # include "algoritmosRSA.h"
    # define ALGORITMOSRSA
# endif // ALGORITMOSRSA


//Prototipos de la tarea 4
bool esPar(const char *);
char decodifica (const char * );
void decodificaMensaje (const char*, char*);

void euclidesExtendido (const char *, const char *, char *, char *, char *);
void inversoModulo (const char *, const char *,  char*);
void potenciaModulo (const char *, const char *,  const char*, char *);

void desencripta (const char *, const char *, const char *, char *);


//Subalgoritmos de la tarea 4

bool esPar (const char * numero)
{
    int digito = numero[strlen(numero)-1]-'0';
    return digito % 2 == 0;
}
char decodifica (const char *codificacion, const char * cadena)
{
    int indice = 10*(cadena[0]-'0')+ cadena[1]-'0';
    return codificacion [indice];
}

void decodificaMensaje (const char* mIn, char* mOut)
{
    unsigned int i;
    char mAux[strlen(mIn)+2], cadena[3];
    if (strlen(mIn)%2 != 0)  strcpy (mAux,"0");
    else  mAux[0] = '\0';
    strcat (mAux, mIn);

    cadena[2]='\0';
    for (i=0; i< strlen(mAux); i+=2)
    {
        cadena[0] = mAux[i];
        cadena[1] = mAux[i+1];
        mOut[i/2] = decodifica (codificacion, cadena);
    }
    mOut [i/2] ='\0';
}

void desencripta (const char * n, const char* d, const char * Mencr, char * texto)
{
    char M[strlen(n)*2+1];
    //char M[longMax];

    potenciaModulo (Mencr,d,n, M);
    decodificaMensaje(M, texto);
}

void euclidesExtendido (const char * n, const char *m, char * mcd, char * a, char * b)
{
    int longN = strlen(n), longM = strlen (m);
    char aAux [longM+1], bAux [longN+1], cociente[longN+1], resto[longN+1];
    //char aAux [longMax], bAux [longMax], cociente[longMax], resto[longMax];

    //cout << "Euclides extendido: " << n <<", " << m<< endl;
    if (strcmp(m,"0") == 0)
    {
        strcpy (mcd, n);
        strcpy (a, "1");
        strcpy (b, "0");
    }
    else
    {
        //cout  << n <<", " << m<< '\t';
        division (n, m, cociente, resto); //cout  << n <<", " << m<< endl;
        euclidesExtendido (m, resto, mcd, aAux, bAux);
        strcpy (a, bAux);
        multiplicacion (cociente, bAux, b);
        resta (aAux, b, b);
    }
}

void inversoModulo (const char * n, const char *m, char * sol)
{
    int lMax = (strlen(n)> strlen(m))? strlen(n):strlen(m);
    char mcd[lMax+1], a[lMax+1];
    //char mcd[longMax], a[longMax], b[longMax];
    euclidesExtendido (n, m, mcd, a, sol);
    if (compara (sol, "0") == -1) suma (sol, n, sol);
}

//Versin recursiva de potenciaModulo
void potenciaModulo (const char * b, const char * e,  const char* n, char * solucion)
{
    int lM = (strlen(n) > strlen(e)) ? strlen(n): strlen(e);
    char resto [strlen(n)+1], cociente[lM+1], sol[2*lM+1];
    //char sol [2*lM+1];
    //char resto [longMax], cociente[longMax], sol[longMax];
    //char resto [longMax], cociente[longMax];

    if ( compara (e,"0") == 0)
        strcpy (sol, "1");
    else if (esPar (e))
    {
        division (e, "2", cociente, resto);
        potenciaModulo (b, cociente, n, sol );
        multiplicacion (sol, sol, sol);
        division (sol, n, cociente, sol);
    }
    else
    {
        resta (e, "1", resto);
        potenciaModulo (b, resto, n, sol);
        multiplicacion (b, sol, sol);
        division (sol, n, cociente, sol);
    }
    strcpy (solucion, sol);

}

//Versin iterativa de potenciaModulo
void potenciaModuloIterativa (const char * b, const char * expo, const char *n, char * resultado)
{
    int lN, lB, lMax;
    lN = strlen (n); lB = strlen (b);
    lMax = (2*lN > lB)?2*lN: lB;
    char factor[2*strlen(n)+1], solucion[2*strlen(n)+1], resto[lN+1], e[strlen(expo)+1], cociente [lMax+1];

    division (b,n,cociente, factor);
    strcpy (solucion, "1");
    strcpy (e, expo);

    while (compara (e, "0") > 0)
    {
        division (e, "2", e, resto);
        if ( compara (resto, "1") == 0)
        {
            multiplicacion (solucion, factor, solucion);
            division (solucion, n, cociente, solucion);
        }
        multiplicacion (factor, factor, factor);
        division (factor, n, cociente, factor);
    }
    strcpy (resultado, solucion);
}
