int buscaPrimo (int nDigitos , char * primo);
//Devuelve un string que representa un entero primo de nDigitos cifras


bool MillerRabin (const char * numero, int k);
/*Decide si un nmero, representado mediante un string, es primo o no.
El parmetro entero k determina el grado de certeza del resultado:
    *   si la funcin devuelve false, tenemos la certeza absoluta
        de que numero NO es primo
    *   si la funcin devuelve true, la probabilidad de error
        (de dar por bueno un nmero que no es primo) es menor de 4^(-k).
        Por ejemplo, si k = 10, la funcin se equivoca en el 4^(-10) * 100 % =
        0.0001 % de las ocasiones
*/

/*
int buscaPrimo (int nDigitos, char * primo);
Descripcin:
    Genera un nmero primo con el nmero de dgitos especificado

Parmetros:
    * nDigitos    nmero de dgitos que se desea que tenga el nmero primo
    * primo       puntero a string que representa un nmero de primos de nDigitos cifras.


Devuelve:
        Un entero: el nmero de pruebas realizadas hasta encontrar el primo

Restricciones:
    La longitud del array primo debe ser, como mnimo, nDigitos+1 caracteres
    (nDigitos para las cifras y un carcter extra para el fin de cadena '\0').

Ejemplo:
    void pruebaPrimos ()
    {
        char p[101];
        int n= buscaPrimo (100, p);
        printf ("p: %s\nHallado tras %d intentos\n", p, n);
    }

*/



/*
bool MillerRabin (const char * numero, int k);

Descripcin:
    Decide si un nmero, representado mediante un string, es primo o no.
    El parmetro entero k determina el grado de certeza del resultado:
        *   si la funcin devuelve false, tenemos la certeza absoluta
            de que numero NO es primo
        *   si la funcin devuelve true, la probabilidad de error
            (de dar por bueno un nmero que no es primo) es menor de 4^(-k).
            Por ejemplo, si k = 10, la funcin se equivoca en el 4^(-10) * 100 % =
            0.0001 % de las ocasiones

Parmetros:
    * numero    puntero a constante. Apunta a un array de caracteres
                que representa un nmero entero. A travs de l no se puede modificar
                el contenido del array.
    * k         entero que determina el grado de certeza del resultado de la funcin.

Devuelve:
    Un booleano (true si el nmero es primo, false si compuesto).

Restricciones:
    Recuerda que, si devuelve true, existe una probabilidad de error. Esa probabilidad
    se maneja mediante el valor de k.

Ejemplo:
void pruebaMillerRabin()
{
    cout << MillerRabin ("78539", 10)<< endl;
    cout << MillerRabin ("12345678987654321", 10)<< endl;
}
Muestra por pantalla:
1
0
*/
